"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateAuthWebhookNextjs = void 0;
const cors_1 = __importDefault(require("cors"));
const cors_middleware_1 = require("./cors-middleware");
exports.generateAuthWebhookNextjs = function generateAuthWebhookNextjs(options) {
    const cors = cors_1.default({ methods: ['GET', 'HEAD'] });
    return (req, res) => __awaiter(this, void 0, void 0, function* () {
        yield cors_middleware_1.corsMiddleware(req, res, cors);
        const bearer = (req === null || req === void 0 ? void 0 : req.headers['Authorization']) || (req === null || req === void 0 ? void 0 : req.headers['authorization']);
        const token = bearer.slice(7);
        if (typeof (token) !== 'string')
            return res.status(400).json({ error: '!token' });
        res.json(yield options.findUserByToken(token));
    });
};
//# sourceMappingURL=auth-webhook.js.map