"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateRemoteSchema = void 0;
const apollo_server_micro_1 = require("apollo-server-micro");
const cors_1 = __importDefault(require("cors"));
const cors_middleware_1 = require("./cors-middleware");
exports.generateRemoteSchema = function generateRemoteSchema(options) {
    const cors = cors_1.default({ methods: ['POST', 'OPTIONS'] });
    const { path } = options, config = __rest(options, ["path"]);
    const apolloServer = new apollo_server_micro_1.ApolloServer(Object.assign({ introspection: true }, config));
    const handler = apolloServer.createHandler({ path });
    return {
        default: (req, res) => __awaiter(this, void 0, void 0, function* () {
            yield cors_middleware_1.corsMiddleware(req, res, cors);
            return yield handler(req, res);
        }),
        config: {
            api: {
                bodyParser: false,
            },
        },
    };
};
//# sourceMappingURL=remote-schema.js.map